
CoCoALib - Feature #1117

Better printing of negative coeffs

07 Nov 2017 12:34 - John Abbott

Status: In Progress Start date: 07 Nov 2017

Priority: Normal Due date:  

Assignee:  % Done: 10%

Category: Improving Estimated time: 0.00 hour

Target version: CoCoALib-1.0 Spent time: 0.25 hour

Description

Currently CoCoALib prints out polys wth negative rational coeffs in an ugly way:

/**/ x-(1/2)*y;

x +(-1/2)*y

 

Improve printing so that we get -( instead of +(-

/**/ x-(1/2)*y;

x -(1/2)*y

Related issues:

Related to CoCoALib - Bug #74: printing polynomials New 22 Dec 2011

Related to CoCoALib - Feature #222: Printing polynomials - spaces between terms In Progress 08 Aug 2012

Related to CoCoALib - Design #432: Semantics of IsPrintedWithMinus In Progress 31 Jan 2014

Related to CoCoALib - Design #1156: Printing for RingElem New 12 Feb 2018

History

#1 - 07 Nov 2017 12:34 - John Abbott

- Related to Bug #74: printing polynomials added

#2 - 07 Nov 2017 12:34 - John Abbott

- Related to Feature #222: Printing polynomials - spaces between terms added

#3 - 07 Nov 2017 12:34 - John Abbott

- Related to Design #432: Semantics of IsPrintedWithMinus added

#4 - 07 Nov 2017 13:39 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

JAA suggests that we handle integer and rational coeffs specially; all other coeffs are handled in a generic way.

Here are some examples:

/**/ use QQ[x,y];

/**/ x-(1/2)*y;  -->  currently prints as x +(-1/2)*y

x-(1/2)*y

/**/  x-(1/2);  // better with or without brackets?

x-1/2
NOTE: currently CoCoA does print the second poly as x -1/2; so no brackets, and special handling for the minus sign!    

If coeff is not rational do not handle "negative" values specially:

/**/ use QQ(a)[x,y];  // not valid CoCoA syntax

/**/ x + (-a+1)*y;

x +(-a+1)*y

 

What about the following:

use QQ(a)[x,y];

/**/ x-a*y;

x +(-a)*y

#5 - 12 Feb 2018 12:30 - John Abbott

- Related to Design #1156: Printing for RingElem added

#6 - 12 Jun 2018 17:12 - John Abbott

- Target version changed from CoCoALib-0.99600 to CoCoALib-0.99650 November 2019

#7 - 23 Sep 2019 11:52 - John Abbott

- Target version changed from CoCoALib-0.99650 November 2019 to CoCoALib-1.0
